<template>
  <div class="level-select-sidebar">
    <div class="level-select-sidebar-row disabled">
      <span>Level</span><span>Score</span>
    </div>
    <div class="level-select-sidebar-row disabled">
      <span>Total</span><span>{{ totalScore() }}</span>
    </div>
    <div class="level-select-sidebar-row"
    v-for="(highScore, index) in highScores"
    :class="[
      { selected: (index + 1 == level) },
      { cleared: highScore },
    ]"
    v-on:click="startNewLevel(index + 1)">
      <span>{{ index + 1 }}</span><span>{{ highScore }}</span>
    </div>
  </div>
</template>

<script lang="ts">
import { store } from '../store'

export default {
  props: {
    level: Number,
    highScores: Array,
  },
  setup() {
    return {
      totalScore() {
        return store.getters.totalScore;
      },
      startNewLevel(level) {
        store.dispatch('startNewLevel', { level });
      },
    }
  },
}
</script>

<style lang="scss">
.level-select-sidebar {
  background: #26282c;
  width: 200px;
  min-height: 100vh;
  box-shadow: 0 10px 10px #0005;
  .level-select-sidebar-row {
    display: flex;
    box-shadow: 0 10px 10px #0005;
    transition: 0.25s;
    position: relative;
    left: 0;
    &.disabled {
      pointer-events: none;
      &:nth-child(odd) span:nth-child(odd) {
        background: #5bc4f6;
      }
      &:nth-child(even) span:nth-child(odd) {
        background: #359bcb;
      }
    }
    &.selected:not(:active) {
      &:not(:hover) {
        margin-right: -20px;
      }
      span:nth-child(odd) {
        background: #e8923b;
      }
    }
    &.cleared:not(.selected):not(:active) {
      &:nth-child(odd) span:nth-child(odd) {
        background: #d0559a;
      }
      &:nth-child(even) span:nth-child(odd) {
        background: #9c3870;
      }
    }
    &:hover {
      margin-right: -100px;
    }
    &:active {
      margin-right: -80px;
      transition: 0s;
      span {
        transition: 0s;
        background: white;
      }
    }
    span {
      flex: 1;
      text-align: right;
      padding: 20px;
      pointer-events: none;
      user-select: none;
      transition: 0.25s;
    }
    &:not(:active):not(.disabled):not(.selected):not(.cleared):nth-child(odd) span:nth-child(odd) {
      background: #c5415a;
    }
    &:not(:active):nth-child(odd) span:nth-child(even) {
      background: #282b2f;
    }
    &:not(:active):not(.disabled):not(.selected):not(.cleared):nth-child(even) span:nth-child(odd) {
      background: #a7374c;
    }
    &:not(:active):nth-child(even) span:nth-child(even) {
      background: #202225;
    }
  }
}
</style>
